data {
	int N;
	array[N] vector[2] Data;
	real m1;
	real m2;
	real sd1;
	real sd2;
}
parameters {
	real p_mu1;
	real p_mu2;
	real<lower = 0.0> p_sgm1;
	real<lower = 0.0> p_sgm2;
        real p_r;
}
transformed parameters {
	vector[2] mu;
        real sgm1;
        real sgm2;
	matrix[2, 2] cov;
        real<lower=-1, upper=1> r;
        r = (inv_logit(p_r) - 0.5) * 2;
	mu[1] = p_mu1 * sd1 + m1;  
	mu[2] = p_mu2 * sd2 + m2;  
        sgm1 = p_sgm1 * sd1 + 0.001;
        sgm2 = p_sgm2 * sd2 + 0.001;
	cov[1][1] = sgm1 * sgm1;
	cov[1][2] = sgm1 * sgm2 * r;
	cov[2][1] = sgm1 * sgm2 * r;
	cov[2][2] = sgm2 * sgm2;
}
model {
	p_mu1 ~ normal(0.0, 10.0);  
	p_mu2 ~ normal(0.0, 10.0);  
	p_sgm1 ~ exponential(0.1);  
	p_sgm2 ~ exponential(0.1);
        p_r ~ normal(0.0, 5.0);
        Data ~ multi_normal(mu, cov);
}
